找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 500|回复: 1

[转贴]:Copy any entity from an XREF or a block.

[复制链接]
发表于 2003-8-21 06:58:32 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
  1. ; By Jeffery P Sanders  Copyright 2002 by JefferyPSanders.com
  2. (defun C:CXF()
  3. ;turn the command echo off
  4. (setvar "cmdecho" 0)
  5. ;save some system variables
  6. (setq origCmddia(getvar "cmddia"))
  7. (setq origFiledia(getvar "filedia"))
  8. ;set some system variables
  9. (setvar "cmddia" 0)
  10. (setvar "filedia" 0)
  11. ;print a string to the command line to define what we are asking for (since entsel only asks for an object)
  12. (princ "\n Select XRef or Block: ")
  13. ;select entity
  14. (if (setq entselected(entsel))                                          
  15.    (progn
  16.     ;save the entity name
  17.     (setq en(car entselected))
  18.     ;save the point selected
  19.     (setq selectedPt(cadr entselected))
  20.     ;get entity group codes
  21.     (setq enlist(entget en))                           
  22.     ; if it is a block
  23.     (if(= "INSERT" (cdr(assoc 0 enlist)))               
  24.       (progn
  25.         ;get the dxf group codes for the first sub-entity
  26.         (setq enlist2(tblNext "block" en))
  27.         ;save the file name of the block
  28.         (setq shortFileName(cdr(assoc 2 enlist2)))
  29.         ;set a mark for the undo command
  30.         (command "undo" "mark")
  31.         ;make the XREF part of the drawing temporarily
  32.         (command "-xref" "bind" shortFileName)
  33.         ;explode the block temporarily
  34.         (command "explode" en)
  35.         ;get the entity at the point selected originally if it exist
  36.         (if (setq eset(ssget selectedPt))
  37.           (progn
  38.              ;get the name of the entity selected
  39.              (setq en(ssname eset 0))
  40.              ;get the DXF group codes of the entity
  41.              (setq enlist(entget en))
  42.              ;make a wblock named "X2"
  43.              (if(findfile "x2.dwg")
  44.                (command "_wblock" "x2" "y" "" selectedPt en "")
  45.                (command "_wblock" "x2" "" selectedPt en "")
  46.              )
  47.              ;undo everything back to the marked position
  48.              (command "undo" "Back")
  49.              ;insert the X2 block
  50.              (setq pt1(getpoint selectedPt "\n Insertion Point: "))
  51.              (command "insert" "*x2" pt1 "" "")
  52.            )
  53.            (alert "*Error* - Select a sub-entity.")
  54.         )
  55.       )
  56.       (alert "*Error* - Select a block or an XREF.")
  57.     )
  58.    )
  59.    (alert "*Error* - Select a block or an XREF please.")
  60. )
  61. ;reset system variables
  62. (setvar "cmddia" origCmddia)
  63. (setvar "filedia" origFiledia)
  64. (setvar "cmdecho" 1)
  65. ;make a clean exit
  66. (princ "\n ...CPYXREF.lsp Complete.  ")
  67. (princ "\n By: Jeffery P. Sanders  7/19/02 Copyright 2002 by jefferypsanders.com")
  68. (princ)
  69. )
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
发表于 2005-2-17 23:12:10 | 显示全部楼层
这里分享一个,网上得来
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-12-18 23:07 , Processed in 0.374737 second(s), 34 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表